=== debian/control ===
Source: proxmark3
Section: misc
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Build-Depends: binutils-multiarch,
               debhelper-compat (= 13),
               gcc-arm-none-eabi,
               libbluetooth-dev,
               libbz2-dev,
               libjansson-dev,
               liblua5.2-dev,
               libnewlib-dev,
               libreadline-dev,
               libssl-dev,
               libwhereami-dev,
               pkg-config,
               python3-all-dev,
               python3-colors,
               python3-sslcrypto,
               qtbase5-dev
Standards-Version: 4.6.2
Homepage: https://github.com/RfidResearchGroup/proxmark3
Rules-Requires-Root: no

Package: proxmark3
Architecture: any
Depends: proxmark3-common (= ${source:Version}),
         proxmark3-firmwares (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: proxmark3-doc
Description: Firmware, flasher, and client for the Proxmark3
 This package contains the client and tools for the Proxmark3. It is
 dedicated to bringing the most out of the new features for Proxmark3 RDV4.0
 new hardware and design but it will also support older hardware revisions.

Package: proxmark3-firmwares
Architecture: all
Depends: ${misc:Depends}
Description: Firmwares for the Proxmark3
 This package contains several firmwares for the Proxmark3. It is
 dedicated to bringing the most out of the new features for Proxmark3 RDV4.0
 new hardware and design but it will also support older hardware revisions.

Package: proxmark3-common
Architecture: all
Depends: python3, ${misc:Depends}
Description: scripts for the Proxmark3
 This package contains scripts for the Proxmark3. It is
 dedicated to bringing the most out of the new features for Proxmark3 RDV4.0
 new hardware and design but it will also support older hardware revisions.

Package: proxmark3-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Firmware, flasher, and client for the Proxmark3
 This package contains the documentation files for the Proxmark3 package. It is
 dedicated to bringing the most out of the new features for Proxmark3 RDV4.0
 new hardware and design but it will also support older hardware revisions.
